



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++中弱符号（弱引用）的意义及实例</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++中弱符号（弱引用）的意义及实例</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:57:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天读别人代码时看到一个&ldquo;#pragma&nbsp;weak&rdquo;，一时没明白，上网研究了一个下午终于稍微了解了一点C、C++中的&ldquo;弱符号&rdquo;，下面是我的理解，不正确的地方望大家指正。</p>
<p>本文主要从下面三个方面讲&ldquo;弱符号&rdquo;：</p>
<p>1. 什么是&ldquo;弱符号&rdquo;？ 它与&ldquo;强符号&rdquo;的区别是什么？</p>
<p>2. 弱符号的有什么作用？</p>
<p>3. 弱符号的实际应用实例</p>
<h2>1.什么是弱符号？</h2>
<p>在WikiPedia中弱符号的定义是：</p>
<div>
<pre class="prettyprint linenums">a weak symbol is a symbol definition in an object file or dynamic library that may be overridden by other symbol definitions
</pre>
</div>
<p>　　</p>
<div>
<pre class="prettyprint linenums">A weak symbol denotes a specially annotated symbol during linking of Executable and Linkable Format (ELF) object files. <br />By default, without any annotation, a symbol in an object file is strong. <br />During linking, a strong symbol can override a weak symbol of the same name. <br />In contrast, two strong symbols that share a name yield a link error during link-time. <br />When linking a binary executable, a weakly declared symbol does not need a definition. <br />In comparison, (by default) a declared strong symbol without a definition triggers an undefined symbol link error.<br />
Weak symbols are not mentioned by C or C++ language standards; as such, inserting them into code is not very portable. <br />Even if two platforms support the same or similar syntax for marking symbols as weak, <br />the semantics may differ in subtle points, e.g. whether weak symbols during dynamic linking at runtime lose their semantics or not
</pre>
</div>
<p>从第一个定义可以知道，&ldquo;弱符号&ldquo;是在一个文件或者动态库中定义的，可以被其他地方定义的符号overridden的符号。这里重点是&ldquo;overridden&rdquo;</p>
<p>从第二个定义，我们可以知道&ldquo;弱符号&rdquo;跟强符号主要有如下区别：</p>
<p>1. 弱符号可以只有申明，没有定义，强符号必须有定义</p>
<p>2. 弱符号可以定义多次，强符号只能定义。</p>
<p>另外第二个定义中还提到，弱符号并不是C、C++规范中的内容，这个跟编译器相关，不可移植。</p>
<p>在中文的很多文章中把weak symbol分为了两种&ldquo;弱符号&rdquo;（变量）&ldquo;弱引用&rdquo;（函数），但WikiPedia中弱符号的例子都是用的函数。</p>
<h2>2.弱符号的作用</h2>
<p>我的理解&ldquo;弱符号变量&ldquo;是C中遗留下来的，它除了引起麻烦，没有什么作用。C语言中凡是<strong>没有初始化的全局变量</strong>都是弱符号变量，如果存在多个同名的弱符号变量，编译器在链接时可以任意选一个（有的编译器选择占用空间最大的那个定义）。这样，你的代码中定义了一个x，忘了初始化，而你用到的某个库中又刚好定义了一个未初始化的x，后果大家可以自己想。C++中不会出现这个问题，因为C++中所有未初始化的全局变量都初始化为0。</p>
<p>弱符号函数的主要作用是为了多态，即使用定义中的&rdquo;overridden&ldquo;，一般在库中使用得比较多，比如你在你的库中为某个函数提供一个默认实现，用户如果想定制化的话可以自己实现一个。</p>
<p>例子：在library_foo.h中什么函数foo为弱符号函数，library_foo.cc中为foo提供一个默认实现，在my_foo.cc中为foo提供一个定制化的实现。</p>
<p>注：定义一个函数为弱函数有两种方式</p>
<p>1. 使用&ldquo;#pragma week function&rdquo;</p>
<p>2. 函数后面加&ldquo;&nbsp;__attribute__((weak))&rdquo;，</p>
<p>我用的gcc好像不支持第一种方式。</p>
<div>
<pre class="prettyprint linenums">//library_foo.h

#ifndef __LIBRARY_FOO_H__<br />
#define __LIBRARY_FOO_H__

void foo() __attribute__((weak));<br />
void f();   

#endif</pre>
</div>
<div>
<pre class="prettyprint linenums">//library_foo.cc

#include &lt;iostream&gt;<br />
#include "library_foo.h"

void foo(){<br />
    std::cout&lt;&lt;"default foo"&lt;&lt;std::endl;<br />
}

void f(){<br />
    foo();<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">//main.cc

#include &lt;iostream&gt;<br />
#include "library_foo.h"

using namespace std;

int main(int argc, char* argv[]){<br />
   f();<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">//my_foo.cc

#include &lt;iostream&gt;

void foo(){<br />
    std::cout&lt;&lt;"My customized foo"&lt;&lt;std::endl;<br />
}</pre>
</div>
<p>编译及运行结果如下：</p>
<div>
<pre class="prettyprint linenums">&gt; g++ library_foo.cc main.cc my_foo.cc -o customized.x<br />
&gt; g++ library_foo.cc main.cc -o not_customized.x<br />
&gt; ./customized.x<br />
my customized foo<br />
&gt; ./not_customized.x<br />
default foo</pre>
</div>
<p>可以看到，当链接my_foo.cc是，使用的是定制的foo.</p>
<h2>3.&nbsp;弱符号的实际应用实例</h2>
<p>在C++库中，如下函数都是弱符号函数</p>
<div>
<pre class="prettyprint linenums">void *operator new(std::size_t);<br />
void *operator new(std::size_t, std::nothrow_t const &amp;) noexcept;<br />
void *operator new[](std::size_t);<br />
void *operator new[](std::size_t, const std::nothrow_t&amp;) noexcept;<br />
void operator delete(void *) noexcept;<br />
void operator delete(void *, std::nothrow_t const &amp;) noexcept;<br />
void operator delete[](void *) noexcept;<br />
void operator delete[](void *, std::nothrow_t const &amp;) noexcept;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv26y9x.html">SDWebImage源码解读 之 SDWebImageCompat</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ggkx09.html">在 &period;NET 4&period;0 中使用 &period;NET 4&period;5 中新增的特性（CallerMemberNameAttribute&sol;CallerFilePathAttribute&sol;CallerLineNumberAttribute）</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq415njq.html">关于system函数的安全性漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ynnyeq.html">【阿里云产品公测】云引擎ACE新手实战基于Wordpress</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0d4m4q.html">为zend studio增加Extjs代码提示功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xno3z8.html">SQL技术内幕一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ze2o29.html">【转】Logistic regression （逻辑回归） 概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1324j9.html">一篇入门的php Class 文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z4wln9.html">Tree Restoring</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m043j8.html">ajax实现无刷新分页效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpy1d59.html">Linux 下源码编译FFMEG</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmvj39.html">Codeforces 1154F Shovels Shop</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rw4148.html">input type&equals;&amp;quot&semi;file&amp;quot&semi;多图片上传   原生html传递的数组集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o41xr1q.html">每日英语：15 places to find inspiration</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmpj4g9.html">hdu多校2C</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppvpkd9.html">51nod 1571 最近等对 &vert; 线段树 离线</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2krxo3q.html">DropdownList 赋初始值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p50zz8.html">【Arduino】超声波模块&lpar;HC-SR04&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3gkkzq.html">Python Twisted系列教程2：异步编程初探与reactor模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zv30z39.html">PCL struct&OpenCurlyDoubleQuote;flann&colon;&colon;SearchParams参数错误</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96ogxj39.html">Qt树形控件QTreeView使用1&mdash;&mdash;节点的添加删除操作 复选框的设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0gw24q.html">15 Linux Split and Join Command Examples to Manage Large Files--reference</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnzgdrq.html">获取java项目 classpath目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1xm0n9.html">iOS开发篇-申请开发者账号流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xk0p09.html">kali2&period;0如何安装中文输入法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1znzy29.html">图解JVM在内存中申请对象及垃圾回收流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wn5kvq.html">Web前端开发如何利用css样式来控制Html中的h1&sol;h2&sol;h3标签不换行</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mwo0eq.html">ios Toll-Free Bridging</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdeo0y8.html">Ibatis中sqlmap参数map中还需要套list的情况如何写？</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm03zl9.html">Ubuntu&lowbar;14&period;04安装docker</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
